Attribute VB_Name = "modFilters"
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

'Layer 2:  Link
Dim countEther As Long

'Layer 3:  Network
Dim countIP As Long
Dim layer3Others As Long
Dim layer3Unk As Long

'Layer 4: Transport
Dim countTCP As Long
Dim countUDP As Long
Dim countICMP As Long
Dim countSNMP As Long
Dim layer4Others As Long
Dim layer4Unk As Long

Public Function filter(ByVal packetNumber As Long) As Boolean
  Dim tempfilter As Boolean
  tempfilter = False
  If IPprotocolFilter(packetNumber) Then tempfilter = True
  If PortFilter(packetNumber) Then tempfilter = True
  If LengthFilter(packetNumber) Then tempfilter = True
  filter = tempfilter
End Function

Private Function LengthFilter(ByVal packetNumber As Long) As Boolean
  If modLibrary.getPacketLen(packetNumber) >= frmEncodings.lblMinLen And _
  modLibrary.getPacketLen(packetNumber) <= frmEncodings.lblMaxLen Then
    LengthFilter = False
  Else
    LengthFilter = True
  End If
End Function

Private Function PortFilter(ByVal packetNumber As Long) As Boolean
  Dim tempfilter As Boolean
  Dim IPprotocol As Long
  
  tempfilter = False
  IPprotocol = modLibrary.getPacketIPtransportProtocol(packetNumber)
  
  If IPprotocol = 6 Then 'TCP
    If frmEncodings.lblTCPSRCmin > modLibrary.getTCPsourcePort(packetNumber) Then tempfilter = True
    If frmEncodings.lblTCPSRCmax < modLibrary.getTCPsourcePort(packetNumber) Then tempfilter = True
    If frmEncodings.lblTCPDSTmin > modLibrary.getTCPdestPort(packetNumber) Then tempfilter = True
    If frmEncodings.lblTCPDSTmax < modLibrary.getTCPdestPort(packetNumber) Then tempfilter = True
  End If
  
  If IPprotocol = 17 Then 'UDP
    If frmEncodings.lblUDPSRCmin > modLibrary.getUDPsourcePort(packetNumber) Then tempfilter = True
    If frmEncodings.lblUDPSRCmax < modLibrary.getUDPsourcePort(packetNumber) Then tempfilter = True
    If frmEncodings.lblUDPDSTmin > modLibrary.getUDPdestPort(packetNumber) Then tempfilter = True
    If frmEncodings.lblUDPDSTmax < modLibrary.getUDPdestPort(packetNumber) Then tempfilter = True
  End If
  
  PortFilter = tempfilter
End Function

'checks ipprotocol filter settings and returns if packet should be filtered
'see http://www.iana.org/assignments/protocol-numbers
Private Function IPprotocolFilter(ByVal packetNumber As Long) As Boolean
  Dim IPprotocol As Long
    
  IPprotocol = modLibrary.getPacketIPtransportProtocol(packetNumber)
    Dim filter As Boolean
    filter = False
  
  Select Case IPprotocol
    Case 1
      If frmEncodings.chkICMP.value = 1 Then filter = True
    Case 2
      If frmEncodings.chkIGMP.value = 1 Then filter = True
    Case 6
      If frmEncodings.chkTCP.value = 1 Then filter = True
    Case 17
      If frmEncodings.chkUDP.value = 1 Then filter = True
    Case Else
        Select Case IPprotocol
          Case 138 To 252 'unassigned
            If frmEncodings.chkUnkTransport = 1 Then filter = True
          Case Else
            If frmEncodings.chkOtherTransport = 1 Then filter = True
        End Select
  End Select
      
  IPprotocolFilter = filter
      
End Function

Private Function UDPfilter() As Boolean
  'If ((frmEncodings.chkSlammerFilter.Value = True) And _
  '  (modProcess.getUDPdestinationport = 1434) And _
  '  (modProcess.getUDPsourceport = 1434)) Then
    
  '  Debug.Print "filtering slammer ";
  '  Debug.Print modProcess.getUDPdestinationport & " " & getUDPsourceport
  '  UDPfilter = True 'return
  'Else
    'Debug.Print modProcess.getUDPdestinationport & " " & getUDPsourceport
  '  UDPfilter = False 'return
  'End If
  
  'messenger spam filter
 ' If (modLibrary.getUDPdestPort(packetlocation) = 1026 Or _
  '    modLibrary.getUDPdestPort(packetlocation) = 1027 Or _
 '     modLibrary.getUDPdestPort(packetlocation) = 1026 Or _
  '    modLibrary.getUDPdestPort(packetlocation) = 1027) Then
      
 '    UDPfilter = False 'return
  'Else
  '  UDPfilter = True 'return
  'End If
  
End Function

Private Function TCPfilter() As Boolean
  'if (not(frmencodings.chkTCPACK))
  
  'If (frmEncodings.chkTCPACK.value And modProcess.getTCPACK) Or _
  '   (frmEncodings.chkTCPSYN.value And modProcess.getTCPSYN) Or _
  '   (frmEncodings.chkTCPSYNACK.value And modProcess.getTCPSYN And modProcess.getTCPACK) Then
  '  TCPfilter = True
  'Else
  '  TCPfilter = False
  'End If
End Function


'Public Sub DisplayForm()
 ' Debug.Print "displaying filters form..."
' frmFilters.Show
'End Sub

'Public Sub ExitForm()
'  frmFilters.Hide
'End Sub
